
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>YUV转RGB（NV21-ARGB）的Neon优化代码 / iVAN</title>

    <meta name="description" content="YUV转RGB（NV21-ARGB）的Neon优化代码 说明 此代码仅限于 NV21 格式转 ARGB 格式. NV21 格式中,Y 单独存储,UV分量交错存储. 使用如下公式: R = Y + 1.402*(V-128); G = Y - 0.34414*(U-128) - 0.71414*(V-128); B = Y + 1.772*(U-128); 浮点乘法用 6位精度处理(即a*b = ((a &lt;&lt; 6)*b )&gt;&gt;6) 代码 #ifdef HAS_NEON #include &lt;arm_neon.h&gt; #e ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">YUV转RGB（NV21-ARGB）的Neon优化代码</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h1>说明</h1>
<p>此代码仅限于 NV21 格式转 ARGB 格式。 <br />
NV21 格式中，Y 单独存储，UV分量交错存储。 <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA2MjQxMTQyMzI3NTE=.jpg"><br />
使用如下公式： <br />
            R = Y + 1.402*(V-128); <br />
            G = Y - 0.34414*(U-128) - 0.71414*(V-128); <br />
            B = Y + 1.772*(U-128); <br />
浮点乘法用 6位精度处理（即a*b = ((a &lt;&lt; 6)*b )&gt;&gt;6）</p>
<h1>代码</h1>
<pre><code>#ifdef HAS_NEON
#include &lt;arm_neon.h&gt;
#endif
void convertToRGBA(unsigned char* yuv, int w, int h, int* rgba)
{
    for (int i=0; i&lt;h; ++i)
    {
        unsigned char* dst = (unsigned char*)(rgba + w*i);
        unsigned char* y = yuv + w*i;
        unsigned char* uv = yuv + w*h + w*(i/2);
        int count = w;
#ifdef HAS_NEON
/*一次处理16个像素*/
        int c = count/16;
        asm volatile(
                "mov r4, %[c]\t\n"
                "beq 2f\t\n"
                "vmov.u8 d7, #255\t\n"//Alpha
                "vmov.u8 d3, #255\t\n"//Alpha
                "vmov.s16 q11, #90\t\n"
                "vmov.s16 q12, #128\t\n"
                "vmov.s16 q13, #21\t\n"
                "vmov.s16 q14, #46\t\n"
                "vmov.s16 q15, #113\t\n"
                "1:\t\n"
                /*Y1 Y2 是交错的两组像素的Y分量，与 UV分量值 正好一一对应*/
                "vld2.8 {d8, d9}, [%[y]]!\t\n"//Y1, Y2
                /*交错取出 UV 值*/
                "vld2.8 {d0, d1}, [%[uv]]!\t\n"//u, v
                "vmovl.u8  q5, d0\t\n"
                "vmovl.u8  q6, d1\t\n"
                "vsub.i16 q5,q5, q12\t\n"//U
                "vsub.i16 q6,q6, q12\t\n"//V
                //First RGBA
                "vshll.u8 q7, d8, #6\t\n"
                "vshll.u8 q8, d8, #6\t\n"
                "vshll.u8 q9, d8, #6\t\n"
                "vmla.i16 q7, q6, q11\t\n"
                "vmls.i16 q8, q5, q13\t\n"
                "vmls.i16 q8, q6, q14\t\n"
                "vmla.i16 q9, q5, q15\t\n"

                "vshr.s16 q7, q7, #6\t\n"
                "vshr.s16 q8, q8, #6\t\n"
                "vshr.s16 q9, q9, #6\t\n"
                "vmov.s16 q10, #0\t\n"
                "vmax.s16 q7, q7, q10\t\n"
                "vmax.s16 q8, q8, q10\t\n"
                "vmax.s16 q9, q9, q10\t\n"
                "vmov.u16 q10, #255\t\n"
                "vmin.u16 q7, q7, q10\t\n"
                "vmin.u16 q8, q8, q10\t\n"
                "vmin.u16 q9, q9, q10\t\n"
                "vmovn.s16 d2, q7\t\n"
                "vmovn.s16 d1, q8\t\n"
                "vmovn.s16 d0, q9\t\n"

                //Second RGBA
                "vshll.u8 q7, d9, #6\t\n"
                "vshll.u8 q8, d9, #6\t\n"
                "vshll.u8 q9, d9, #6\t\n"
                "vmla.i16 q7, q6, q11\t\n"
                "vmls.i16 q8, q5, q13\t\n"
                "vmls.i16 q8, q6, q14\t\n"
                "vmla.i16 q9, q5, q15\t\n"
                "vshr.s16 q7, q7, #6\t\n"
                "vshr.s16 q8, q8, #6\t\n"
                "vshr.s16 q9, q9, #6\t\n"
                "vmov.s16 q10, #0\t\n"
                "vmax.s16 q7, q7, q10\t\n"
                "vmax.s16 q8, q8, q10\t\n"
                "vmax.s16 q9, q9, q10\t\n"
                "vmov.u16 q10, #255\t\n"
                "vmin.u16 q7, q7, q10\t\n"
                "vmin.u16 q8, q8, q10\t\n"
                "vmin.u16 q9, q9, q10\t\n"
                "vmovn.s16 d6, q7\t\n"
                "vmovn.s16 d5, q8\t\n"
                "vmovn.s16 d4, q9\t\n"
/*目前我们得到的两组RGB分量值是交错的，
* 比如：
* d0 : (g0 g2 g4 g6 g8 g10 g12 g14)
* d4 : (g1 g3 g5 g7 g9 g11 g13 g15)
* 需要做交织，变成如下再存储：
* d0 ：(g0 g1 g2 g3 g4 g5 g6 g7)
* d4 ：(g8 g9 g10 g11 g12 g13 g14 g15)
*/

                "vtrn.8 d2,d6\t\n"
                "vtrn.16 d2,d6\t\n"
                "vtrn.32 d2,d6\t\n"

                "vtrn.8 d1,d5\t\n"
                "vtrn.16 d1,d5\t\n"
                "vtrn.32 d1,d5\t\n"

                "vtrn.8 d0,d4\t\n"
                "vtrn.16 d0,d4\t\n"
                "vtrn.32 d0,d4\t\n"

                "vst4.8 {d0-d3}, [%[dst]]!\t\n"
                "vst4.8 {d4-d7}, [%[dst]]!\t\n"

                "subs r4, r4, #1\t\n"
                "bne 1b\t\n"
                "2:\t\n"
                : [dst] "+r" (dst), [y] "+r" (y), [uv] "+r" (uv), [c] "+r" (c)
                :
                : "r4", "cc","memory", "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7","d8","d9","d10","d11","d12","d13","d14","d15","d16","d17","d18","d19","d20","d21","d22","d23","d24","d25","d26","d27","d28","d29","d30","d31"
                );
        count%=16;
#endif

/*边角料的处理*/
        int r, g, b;
        while (count &gt; 1)
        {
            unsigned char _y = y[0];
            unsigned char _u = uv[0];
            unsigned char _v = uv[1];
            r = _y + ((179*(_v-128))&gt;&gt;7);
            g = _y - ((43*(_u-128) - 91*(_v-128))&gt;&gt;7);
            b = _y + ((227*(_u-128))&gt;&gt;7);
            r = r&lt;0?0:r;r=r&gt;255?255:r;
            g = g&lt;0?0:g;g=g&gt;255?255:g;
            b = b&lt;0?0:b;b=b&gt;255?255:b;
            dst[0] = b;
            dst[1] = g;
            dst[2] = r;
            dst[3] = 0xFF;

            y++;
            dst+=4;
            _y = y[0];

            r = _y + ((179*(_v-128))&gt;&gt;7);
            g = _y - ((43*(_u-128) - 91*(_v-128))&gt;&gt;7);
            b = _y + ((227*(_u-128))&gt;&gt;7);
            r = r&lt;0?0:r;r=r&gt;255?255:r;
            g = g&lt;0?0:g;g=g&gt;255?255:g;
            b = b&lt;0?0:b;b=b&gt;255?255:b;

            dst[0] = b;
            dst[1] = g;
            dst[2] = r;
            dst[3] = 0xFF;
            y++;
            uv+=2;
            dst+=4;

            count-=2;
        }
        if (count &gt; 0)
        {
            unsigned char _y = y[0];
            unsigned char _u = uv[0];
            unsigned char _v = uv[1];
            r = _y + ((179*(_v-128))&gt;&gt;7);
            g = _y - ((43*(_u-128) - 91*(_v-128))&gt;&gt;7);
            b = _y + ((227*(_u-128))&gt;&gt;7);
            r = r&lt;0?0:r;r=r&gt;255?255:r;
            g = g&lt;0?0:g;g=g&gt;255?255:g;
            b = b&lt;0?0:b;b=b&gt;255?255:b;
            dst[0] = b;
            dst[1] = g;
            dst[2] = r;
            dst[3] = 0xFF;
        }
    }
}</code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-05 05:18:45</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>YUV转RGB（NV21-ARGB）的Neon优化代码的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwxqwRb.html" rel="bookmark">图像转置的Neon优化代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				图像转置的Neon优化代码 原理 图像转置 图像转置和矩阵转置是一样的,其公式为: dst.getPixels(y, x) = src.getPixels(x, y) dst.w = src.h dst.h = src.w 效果如下: 原图: 结果图: 先做图像转置后,再实现90度/270度的旋转相对容易, 如图像旋转90度,就只需要再水平翻转一下: 旋转结果图: 分而治之 图像转置的优化思路是: 1.将图像分割成一系列小矩阵. 分成的小矩阵当然是越大越好,但在矩阵变大时,汇编代码的复杂度变高,			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/LzJk8wb.html" rel="bookmark">常用YUV转RGB代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				常用YUV转RGB  [java] view plaincopyprint? public class YuvToRGB {       private static int R = 0;       private static int G = 1;       private static int B = 2;       //I420是yuv420格式,是3个plane,排列方式为(Y)(U)(V)       public static int[] I420ToRGB(byte[] sr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBKEPOM.html" rel="bookmark">RGB图像数据字符叠加，图像压缩（ijl库），YUV转RGB</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				jackyhwei 发布于 2010-01-01 12:02 点击:3218次  来自:CSDN.NET 一些非常有用的图像格式转换及使用的源代码,包括RGB图像数据字符叠加,图像压缩(ijl库),YUV转RGB等等. TAG: YUV  YUV转RGB  RGB  BMP转JPG  文字叠加     /**************************************File: yuvrgb24.hDescription: header file for yuvrgb24.cDate			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwWvrEz.html" rel="bookmark">什么是YUV、RGB？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				由来 通常我们用RGB表示一种彩色.计算机系统里的LCD显示的数据就是RGB来表示每个像素的颜色.而在我们生活里,有黑白电视机与彩色电视机两种,拍摄节目源时不可以用两种不同的摄像机来存放两种图像数据.所以为了兼容两种电视机,专家就引入YUV格式代替RGB,其中Y表示亮度, U和V表示色差. 黑白电视机只用Y信号, 而彩色电视机可由YUV转换成RGB再显示颜色.通常我们所用的YUV格式是 ITU-R 的标准 , 也叫YCbCr. YUV与RGB的换算规则 Y Y = 0.299 x R + 0.5			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRLa0ez.html" rel="bookmark">Converting Between YUV and RGB</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				It is frequently necessary to convert between YUV pixel formats (used by the JPEG and MPEG compression methods) and RGB format (used by many hardware manufacturers.) The following formulas show how to compute a pixel's value in one format from the pi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRYrg3b.html" rel="bookmark">YUV和RGB格式分析【转】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://www.cnblogs.com/silence-hust/p/4465354.html 做嵌入式项目的时候,涉及到YUV视频格式到RGB图像的转换,虽然之前有接触到RGB到都是基于opencv的处理,很多东西并不需要我们过多深入的去探讨,现在需要完全抛弃现有的算法程序,需要从内存中一个字节一个字节的处理,这就涉及到各个视频格式和图片格式是如何存储的.看了网上的很多资料,一下资料帮助蛮大. YUV资料整理: http://www.fourcc.org/yuv.php    YU			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMggoAM.html" rel="bookmark">优化代码：网页技术CSS的font属性的缩写的技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				css|技巧|网页|优化 优化代码:网页技术CSS的font属性的缩写的技巧,缩写有利于减少代码,优化CSS,使之更加合理. css font属性是用来控制文字字体.颜色.大小等.而font的属性有多种,在通常情况下,我们用缩写的办法将多种属性概括在一句css代码中.这样极大的减小了代码,优化css文件. 我们常用的font属性有下面这六种: font-style设定斜体 如:font-style: italic;font-weight设定文字粗细 如:font-weight: bold;fon			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7kRZAz.html" rel="bookmark">用Visual C&plus;&plus;优化代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要:本文介绍了Visual C++ .NET 2003产品中提供的代码优化功能.此外,对于那些还不熟悉 Visual C++ .NET 2002 中进行的改进的读者,本文还用一个较短的部分介绍了在这一改进中引入的新的&quot;全程序优化&quot;功能.最后,本文讨论了一些与优化有关的&quot;最佳策略&quot;,以及对 Visual C++ 编译器进行的一般性增强. 简介 虽然得到了一种新的工具,但对于自己是否以可能的最佳方式使用它没有把握,这总是一件令人感到沮丧的事情.该白皮书试图减少您对 V			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgR598b.html" rel="bookmark">eden space 100 used-jvm内存怎么设置&comma;以及如何优化代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 jvm内存怎么设置,以及如何优化代码 写了一个web程序,可以根据输入的内容抓取网口信息以及串口信息,分别使用了: Jpcap.dll,rxtxSerial.dll 单独开一个测试时正常,但是同时开两个抓取,tomcat就会挂掉,然后生成一个: hs_err_pidXXXX.log文件 于是百度了一下,感觉是jvm内存的问题,就调整了一下: -Xms1024m -Xmx1024m -Xmn600m -XX:PermSize=653m -XX:MaxPermSize=653m -XX:P			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlgVbx.html" rel="bookmark" class="title">delphi编程控制INI文件</a>
					<div>
						从.INI文件中获取字符串 var strResult:pchar; begin GetPrivateProfileString( 'windows', // []中标题的名字 'NullPort', ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPvarb.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;美女站长&rdquo; &mdash;&mdash;不能承受之重</a>
					<div>
						又一个不眠之夜-相信绝大多数站长都会感同身受 留下你在建站期间最难忘的经历或感受··· 不知不觉又在电脑前坐了一夜 起身倒杯水  天已经微微的发白 除了头疼 精神还算不错 照照镜子 大概很久没有好好看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnyX2M.html" rel="bookmark" class="title">谈SEO公司如何提升外链专员的工作积极性</a>
					<div>
						  外链专员作为SEO职业中最普遍的职位,在SEO公司的招聘信息上经常可以看到,外链专员的需求量还是很大的,中小企业站最基本最重要的工作就是外链建设.但外链专员的技能要求比较低,只要懂上网,再有人指导 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMRaQkb.html" rel="bookmark" class="title">频繁更换主题也可以不影响网站排名</a>
					<div>
						我想,很多朋友在接触网站时,都喜欢频繁的更换网站主题,为什么呢? 主要是现在的好看的主题太多了,看到好的,就像换掉以前觉得不好看的,话说本人当年也是如此,而且乐此不疲,最高纪录曾一天换了8个主题,当真 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jEBVb.html" rel="bookmark" class="title">使用VisualStudio2010从分析到实施（5）&mdash;使用Component Diagram设计系统结构</a>
					<div>
						前言 需求分析和总体流程设计完成后,我们接下来开始设计系统结构.本篇将向大家介绍使用VisualStudio 2010中对Component Diagram(组件图)的支持,和使用VisualStud ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4dG0p.html" rel="bookmark" class="title">用XSLT和XML改进Struts</a>
					<div>
						摘要 Struts是一个优秀的Java Web开发框架.Struts是Apache项目之一,现在Struts已经在Java开发团体中得到了广泛的支持.在这篇文章中Julien Mercay 和Gilb ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Nq97z.html" rel="bookmark" class="title">Oracle数据库安全之Oracle标签安全（OLS）</a>
					<div>
						在上一篇文章中讨论了如何利用VPD对Oracle表中的行进行访问控制(见&lt;[Oracle] 数据 库安全之 - 虚拟私有数据库 (VPD)&gt;),下面介绍一种比VPD复杂一点的访问控制技术- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk2jDdM.html" rel="bookmark" class="title">电脑反复重启的原因和解决办法</a>
					<div>
						脑总是重启肯定会影响我们的正常使用,那么这个问题怎么解决呢?这里就教你解决电脑重启问题,轻松.快捷. 首先,检查插座和电脑的线路连接.插座的铜片被氧化,会导致电源插头接触不良,导致电脑电压不稳定,引起 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYY8AM.html" rel="bookmark" class="title">Photoshop把风景照处理成水墨山水画效果</a>
					<div>
						本实例主要讲述利用PS来处理合成&quot;水墨山水画&quot;,不会水墨画又想过下瘾的朋友可以一试,本实例是在转素描的基础上进一步加工而成,另外讲述一些装裱画的合成内容,有兴趣的可以看看. pho ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WYkAb.html" rel="bookmark" class="title">解决win8系统下iTunes重复安装失败的方法</a>
					<div>
						  iTunes 是由苹果电脑推出的一款免费的数字媒体播放应用程序,安装完成后就能很方便的管理和播放音乐.视频等,最近有网友反应在win8系统下安装iTunes出错,不但安装失败,而且还一直重复安装个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WDOPb.html" rel="bookmark" class="title">平安wifi搜不到无线网络怎么办</a>
					<div>
						  平安wifi搜不到无线网络怎么办 平安免费wifi怎么用教程 当平安免费wifi应用一直提示:下拉可以搜索周边的热点哦!其实就是一直搜不到周边免费wifi网络. 其实这里要注意一下,平安wifi所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Z8kZb.html" rel="bookmark" class="title">如何在iPhone上建立第一个机器学习模型</a>
					<div>
						引言 作为一名数据科学家,我一直有一个梦想--顶级科技公司在与我相关的领域不断推出新产品. 如果你观看了Apple公司最新的iPhone X发布会,你会发现iPhone X具有非常酷的特性,比如Fac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywjDJz.html" rel="bookmark" class="title">如何用Go实现单链表</a>
					<div>
						一.概念介绍 下面这副图是我们单链表运煤车队. 每节运煤车就是单链表里的元素,每节车厢里的煤炭就是元素中保存的数据.前后车通过锁链相连,作为单链表运煤车,从1号车厢开始,每节车厢都知道后面拉着哪一节车 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZdL4oM.html" rel="bookmark" class="title">iOS开发之数据存储之NSData</a>
					<div>
						1.概述 使用archiveRootObject:toFile:方法可以将一个对象直接写入到一个文件中,但有时候可能想将多个对象写入到同一个文件中,那么就要使用NSData来进行归档对象. NSDat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPY6mp.html" rel="bookmark" class="title">一些相见恨晚的 JavaScript 技巧&lowbar;javascript技巧</a>
					<div>
						JavaScript 的成功让人津津乐道,为 Web 网页编写 JavaScript 代码已经是所有 Web 设计师的基本功,这门有趣的语言蕴藏着许多不为人熟知的东西,即使多年的 JavaScript ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEBEwp.html" rel="bookmark" class="title">关于WPF程序在win7系统下不能打印控件的问题</a>
					<div>
						问题描述 RT,最近到客户现场实施发现WPF程序在win7系统下打印控件为空,也就是打印机打印出来的是白纸,啥都没有,在win8系统下可以打印内容,有人遇到过这个问题么? 解决方案 解决方案二:没遇到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVWk1b.html" rel="bookmark" class="title">mxgraph-mxGraph学习求大神指导</a>
					<div>
						问题描述 mxGraph学习求大神指导 mxGraph怎么学习啊,新手表示很有压力啊,没接触过,哪个大神指导一下啊					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6lQ5z.html" rel="bookmark" class="title">safari-html5 中input 的required的标签在Safari中不支持</a>
					<div>
						问题描述 html5 中input 的required的标签在Safari中不支持 html5 中input 的required的标签在Safari中不支持,请问如何才可以在Safari浏览器中实现必 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9Y7ZKM.html" rel="bookmark" class="title">女站长浅谈：关于小说网站SEO优化问题</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 前言:在A5其实已经发表过2次自己 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6Gn0b.html" rel="bookmark" class="title">华为笔试题10道</a>
					<div>
						1 求两个长长整型的数据的和并输出 #include &lt;iostream&gt; using namespace std; void main() { char num1[50]; char n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My379Ez.html" rel="bookmark" class="title">云计算简单知识整理</a>
					<div>
						MapReduce 是一种算法,用于超大型数据集的并行运算: HDFS 支持千万级的大型分布式文件系统: HBase 是一个面向列的分布式数据库: Hive 是DataWareHouse 和 Map  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAlDOM.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;暗黑客栈&rdquo;，神秘黑客獠牙浮现</a>
					<div>
						一个&quot;有故事&quot;的漏洞 黑客大牛余弦曾经说过: 每个漏洞都像一个孩子,我看着它出生,璀璨地爆发,然后又归于沉寂.就好像我的生命和它产生了某种联系. 如果一个漏洞只是被白帽子发现,然后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm691jz.html" rel="bookmark" class="title">项目压缩包-压缩包损坏了能修复吗，刚下载完就打不开了</a>
					<div>
						问题描述 压缩包损坏了能修复吗,刚下载完就打不开了 拜托拜托有没有大神救我....压缩包下载出错打不开了,花了8c币呢,没有票票了 解决方案 winrar和好压都有修复压缩文件功能 解决方案二: 幸运 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVxWAb.html" rel="bookmark" class="title">你会用吗？Linux五大数据可视化工具</a>
					<div>
						可视化工具的简短列表 在本文中,将对很多流行的 Linux 数据可视化工具进行一下调查,并对其中一些工具进行更深入的探讨.例如,某个工具是否为进行数值计算而提供了一种语言?这个工具是交互式的还是提供了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrX0y4z.html" rel="bookmark" class="title">PostgreSQL 10&period;0 preview 性能增强 - 间接索引&lpar;secondary index&rpar;</a>
					<div>
						标签 PostgreSQL , 10.0 , 间接索引 , 第二索引 背景 我们知道,PostgreSQL的MVCC是多版本来实现的,当更新数据时,产生新的版本. 那么如果新版本不在同一个数据块的时候 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKo2gb.html" rel="bookmark" class="title">台积电张忠谋：一切在控制中增幅不变</a>
					<div>
						新浪科技讯 3月17日消息,据台湾媒体报道,受日本大地震的影响,不少外资公司已下调半导体第二季度的增长率.台积电董事长张忠谋表示,一切在控制中,全年增长幅度不变.张忠谋近日表示,日本大地震发生后,台积 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWdYkz.html" rel="bookmark" class="title">Ubuntu Apache配置以及cgi配置方法&lowbar;Linux</a>
					<div>
						在学习Python CGI中,需要在Ubuntu下安装Apache,所以今天在Ubuntu11.04上对Apache的安装和配置进行了学习. 一.Apache的安装  在网上查了些资料有两种安装方式: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXxwyz.html" rel="bookmark" class="title">360诉腾讯垄断案：腾讯是否具有市场支配地位？</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 判断腾讯是否具有市场支配地位的前提是界定相关市场,但是,国内反垄断法主要是原则性规定,唯一操作细则即&lt;国务院反垄断委员会关于相关市场界定的指南&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5YvAp.html" rel="bookmark" class="title">ios-怎么让webview里面显示的网页分辨率能达到iphone6或者6p的分辨率呢？</a>
					<div>
						问题描述 怎么让webview里面显示的网页分辨率能达到iphone6或者6p的分辨率呢? 我自己测试用,打开一个webview.加载一个本地的网页,可是在6p上测试感觉有一点点模糊,可不可以用什么办 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeojnNM.html" rel="bookmark" class="title">乐视股票21日起停牌，集成播控平台变&OpenCurlyDoubleQuote;黑屏&rdquo;</a>
					<div>
						今天(8月21日)早间,深交所发布了乐视公司股票临时停牌的公告: 公共传媒出现关于乐视网信息技术(北京)股份有限公司的信息,可能对公司股票交易价格产生较大影响,根据本所&lt;创业板股票上市规则&gt ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
